#!/bin/nawk -f
# All Rights Reserved Copyright 2008 FUJITSU LIMITED
# ****************************************************************************
# * ǽ     :塼륳ޥ
# * ¹Է     :cvtlinit_sol.sh [-sys ֥ƥֹ]
# * ѥ᥿ :֥ƥֹоݤȤʤ륵֥ƥֹ
# ****************************************************************************
# * ǿ      
# * 0001  2008/05/30  
# *
# ****************************************************************************
BEGIN {
	# OS̾
	"uname" | getline osname
	close("uname")

	# ץåפ
	"uname -p" | getline proname

	# ե̾
	TMPFILE = "/tmp/cvtlinit.tmp"

	#*********************************************************************
	# Ѵ
	#*********************************************************************
	# 顼
	ERRMSG_OVER         = 1
	ERRMSG_BADFORMAT    = 2
	ERRMSG_BADSUBSYSTEM = 3
	ERRMSG_GETFAILED    = 4
	ERRMSG_DELFAILED    = 5
	MSG_OKEY_1          = 6
	MSG_OKEY_2          = 7
	ERRMSG_USAGE        = 8

	# 顼åե
	errmsgfilename = "cvtlinit_errmsg"
	pwdir = "/var/opt/FJSVcvtl/command"
	errmsgpath = sprintf("%s/%s", pwdir, errmsgfilename)

	# iconvޥ
	ICONVCMD = "/usr/bin/iconv"

	# LANG
	mylang = sprintf("%s", ENVIRON["LANG"])

	# iconvѴơ֥
	if (osname == "SunOS") {
		# Solarisξ
		iconveuc = "eucJP"
		if (mylang == "ja_JP.PCK") {
			# SJIS
			toiconv = "PCK"
		} else {
			if (mylang == "ja_JP.UTF-8") {
				# UTF-8
				toiconv = "UTF-8"
			}
		}
	} else {		# Linuxξ
		iconveuc = "EUC-JP-MS"
		if (mylang == "ja_JP.WINDOWS-31J") {
			# SJIS
			toiconv = "CP932"
		} else {
			if ((mylang == "ja_JP.UTF-8") || (mylang == "ja_JP.utf8")) {
				# UTF-8
				toiconv = "UTF-8"
			}
		}
	}

	# åΥѴ
	if (mylang == "ja_JP.PCK" || mylang == "ja_JP.UTF-8" || mylang == "ja_JP.utf8" || mylang == "ja_JP.WINDOWS-31J") {
	errmsgcmd = sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, errmsgpath)
	} else {
		errmsgcmd = sprintf("cat %s", errmsgpath)
	}

	# åɤ߹
	while (errmsgcmd | getline > 0) {
		errmsgrl = $0
		# ԤޤϹƬ"#"ξɤФ
		if (errmsgrl == "" || errmsgrl ~ /^\#/) {
			continue
		}

		split(errmsgrl, edata, ",")

		# ǡɤ߹˳Ǽ
		errmsg[edata[1]] = edata[2]
	}
	close(errmsgcmd)

	#*********************************************************************
	# main
	#*********************************************************************
	# С󤪤ӥǥ
	rc = get_version(ver_array)
	if (rc != 0) {	#
		exit (1)
	}
	version = ver_array[1]
	edition = ver_array[2]
	# 
	sys_flag = 0
	all_flag = 0
	for (i=1; i<ARGC; i++) {
		if (ARGV[i] == "-sys") {
			if (sys_flag == 1) {
				printf("%s\n", errmsg[ERRMSG_OVER])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (1)
			}
			# SEξϥ顼
			if (edition ~ /Standard Edition/) {
				printf("%s\n", errmsg[ERRMSG_BADFORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (1)
			}
			# 
			if (ARGV[i+1] == "all") {
				all_flag = 1
			} else {
				rc = sys_proc(ARGV[i+1])
				if (rc != 0) {	
					exit (1)
				}
				subsystem = ARGV[i+1]
			}
			sys_flag = 1
			i = i + 1
			continue
		} else {
			# ʤ
			if (ARGV[i] == "") {
				break
			} else {
				printf("%s\n", errmsg[ERRMSG_BADFORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (1)
			}
		}
	}

	# ֥ƥֹά
	if (sys_flag == 0) {
		subsystem = 0
	}

	# ץȤκ
	if (all_flag == 1) { # ֥ƥ"all"
		allerr_flag  = 1
		stemerr_flag = 0
		for (i=0; i<=9; i++) {
			rc = jobschprint2stemSchDelete_proc(i, all_flag)
			if (rc == 0) {
				allerr_flag = 0
			} else if (rc == 2) {
				stemerr_flag = 1
			}
		}
		if ((allerr_flag ==1) || (stemerr_flag == 1)) {
			exit (1)
		}
	} else {
		rc = jobschprint2stemSchDelete_proc(subsystem, all_flag)
		if (rc != 0) {	# 顼
			exit (1)
		}
	}

	exit (0)
} 



#*****************************************************************************
# С󤪤ӥǥξ
#       ver_array  :Ѥ
#   ֤  0  :ｪλ
#           1  :۾ｪλ 
#*****************************************************************************
function get_version(ver_array) {
	# swpkginfoޥ
	cmd = "/opt/FJSVftlo/bin/swpkginfo"
	# ޥɤ¸ߤǧ
	rc_getver = system(sprintf("ls %s >/dev/null 2>&1", cmd))
	if (rc_getver != 0) {
		printf("%s\n", errmsg[ERRMSG_GETFAILED])
		return (1)
	}
	
	ver_array[1] = ""
	ver_array[2] = ""
	ver_flag = 0
	while (cmd | getline > 0) {
		rl = $0
		# ǥξ󤬤Ԥ
		if ((rl ~ /PRODUCTNAME/) && (rl ~ /Systemwalker Operation Manager/)) {
			ver_array[2] = rl
			ver_flag = 1
		}
		# Сξ󤬤Ԥ
		if ((rl ~ /VERSION/) && (ver_flag == 1)) {
			ver_array[1] = rl
			ver_flag = 0
		}
	}
	close(cmd)
	# Сޤϥǥμ˼
	if ((ver_array[1] == "") || (ver_array[2] == "")) {
		printf("%s\n", errmsg[ERRMSG_GETFAILED])
		return (1)
	}
	return (0)
}



#*****************************************************************************
# ֥ƥηå
#       subsystem :֥ƥֹ
#   ֤  0  :ｪλ
#           1  :۾ｪλ
#*****************************************************************************
function sys_proc(subsystem) {
        # ξ
	if (subsystem == "") {
		printf("%s\n", errmsg[ERRMSG_BADSUBSYSTEM])
		return (1)
	}
	# Ǥʤ
	for (j=1; j<=length(subsystem); j++) {
		if (substr(subsystem,j,1) ~ "[0-9]") {
			continue
		} else {
			printf("%s\n", errmsg[ERRMSG_BADSUBSYSTEM])
			return (1)
		}
	}
	# ϰϳξ
	if (subsystem < 0 || 9 < subsystem) {
		printf("%s\n", errmsg[ERRMSG_BADSUBSYSTEM])
		return (1)
	}
	return (0)
}



#*****************************************************************************
# jobschprint -oޥɤǥץȤstemSchDeleteޥɤǺ
#       subsystem :֥ƥֹ
#           all_flag  :"all"ե饰
#   ֤  0  :ｪλ
#           1  :۾ｪλ
#           2
#*****************************************************************************
function jobschprint2stemSchDelete_proc(subsystem, all_flag) {
	# jobschprint -o ޥɤ¹
	prj_lst[1]=""
	rc = jobschprint_o_proc(subsystem, all_flag, prj_lst)
	if (rc != 0) {
		return (1)
	}

	# ץȤ¸ߤʤä硢⤻exit
	if (prj_lst[1] == "") {
		return (0)
	}

	# ǧåɽ
	ARGC = 1 
	printf("%s%s%s\n", errmsg[MSG_OKEY_1], subsystem, errmsg[MSG_OKEY_2])
	while (1) {
		getline input
		if ((toupper(input) =="Y") || (toupper(input) == "YES")) {
			break
		} else if ((toupper(input) == "N") || (toupper(input) == "NO")) {
			return (0)
		}	
	}

	# stemSchDeleteޥɤӥåΥѥ
	# Solarisξ
	if (osname == "SunOS") {
		# V13.0SEξ
		if ((version ~ /13.0/) && (edition ~ /Standard Edition/)) {
			cmd_stemSchDelete = sprintf("%s/../etc/init/sol/13.0/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/sol/13.0/messages/ja/FJSVstem /usr/lib/locale/ja/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/sol/13.0/messages/ja_JP.PCK/FJSVstem /usr/lib/locale/ja_JP.PCK/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
		# V13.2SEξ
		} else if ((edition ~ /Standard Edition/) && (version ~ /13.2/)) {
			cmd_stemSchDelete = sprintf("%s/../etc/init/sol/13.2/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/sol/13.2/messages/ja/FJSVstem /usr/lib/locale/ja/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/sol/13.2/messages/ja_JP.PCK/FJSVstem /usr/lib/locale/ja_JP.PCK/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/sol/13.2/messages/ja_JP.UTF-8/FJSVstem /usr/lib/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
		# V13.3SEξ
		} else if ((edition ~ /Standard Edition/) && (version ~ /13.3/)) {
			cmd_stemSchDelete = sprintf("%s/../etc/init/sol/13.3/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/sol/13.3/messages/ja/FJSVstem /usr/lib/locale/ja/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/sol/13.3/messages/ja_JP.PCK/FJSVstem /usr/lib/locale/ja_JP.PCK/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/sol/13.3/messages/ja_JP.UTF-8/FJSVstem /usr/lib/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem >/dev/null 2>&1", pwdir))
		} else {
			cmd_stemSchDelete = "/opt/FJSVstem/bin/stemSchDelete"
		}
	# Linux for Itaniumξ
	} else if (proname == "ia64") {
		# V13.0SEξ
		if ((version ~ /13.0/) && (edition ~ /Standard Edition/)) {
			cmd_stemSchDelete = sprintf("%s/../etc/init/lin64/13.0/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/lin64/13.0/messages/ja_JP.eucJP/FJSVstem.msg /usr/share/locale/ja_JP.eucJP/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin64/13.0/messages/ja_JP.WINDOWS-31J/FJSVstem.msg /usr/share/locale/ja_JP.WINDOWS-31J/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin64/13.0/messages/ja_JP.UTF-8/FJSVstem.msg /usr/share/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem.cat", pwdir))
		# V13.2SEξ
		} else if ((edition ~ /Standard Edition/) && (version ~ /13.2/)) {
			rc = get_release(rel_array)
			if (rc != 0) {
				return (1)
			}
			if (rel_array[1] == "RedHat4") {
				cmd_stemSchDelete = sprintf("%s/../etc/init/lin64/13.2/stemSchDelete", pwdir)
			} else {
				cmd_stemSchDelete = sprintf("%s/../etc/init/lin64/13.2/l5/stemSchDelete", pwdir)
			}
			system(sprintf("ln -s %s/../etc/init/lin64/13.2/messages/ja_JP.eucJP/FJSVstem.msg /usr/share/locale/ja_JP.eucJP/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin64/13.2/messages/ja_JP.WINDOWS-31J/FJSVstem.msg /usr/share/locale/ja_JP.WINDOWS-31J/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin64/13.2/messages/ja_JP.UTF-8/FJSVstem.msg /usr/share/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
		# V13.3SEξ
		} else if ((edition ~ /Standard Edition/) && (version ~ /13.3/)) {
			cmd_stemSchDelete = sprintf("%s/../etc/init/lin64/13.3/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/lin64/13.3/messages/ja_JP.eucJP/FJSVstem.msg /usr/share/locale/ja_JP.eucJP/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin64/13.3/messages/ja_JP.WINDOWS-31J/FJSVstem.msg /usr/share/locale/ja_JP.WINDOWS-31J/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin64/13.3/messages/ja_JP.UTF-8/FJSVstem.msg /usr/share/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
		} else {
			cmd_stemSchDelete = "/opt/FJSVstem/bin/stemSchDelete"
		}
	# Linuxξ
	} else {
		# V13.0SEξ  
		if ((version ~ /13.0/) && (edition ~ /Standard Edition/)) {
			cmd_stemSchDelete = sprintf("%s/../init/lin32/13.0/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/lin32/13.0/messages/ja_JP.eucJP/FJSVstem.msg /usr/share/locale/ja_JP.eucJP/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin32/13.0/messages/ja_JP.UTF-8/FJSVstem.msg /usr/share/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
		# V13.2SEξ
		} else if ((edition ~ /Standard Edition/) && (version ~ /13.2/)) {
			rc = get_release(rel_array)
			if (rc != 0) {
				return (1)
			}
			if (rel_array[1] == "RedHat4") {
				cmd_stemSchDelete = sprintf("%s/../etc/init/lin32/13.2/stemSchDelete", pwdir)
			} else {
				cmd_stemSchDelete = sprintf("%s/../etc/init/lin32/13.2/l5/stemSchDelete", pwdir)
			}
			system(sprintf("ln -s %s/../etc/init/lin32/13.2/messages/ja_JP.eucJP/FJSVstem.msg /usr/share/locale/ja_JP.eucJP/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin32/13.2/messages/ja_JP.UTF-8/FJSVstem.msg /usr/share/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
		# V13.3SEξ
		} else if ((edition ~ /Standard Edition/) && (version ~ /13.3/)) {
			cmd_stemSchDelete = sprintf("%s/../etc/init/lin32/13.3/stemSchDelete", pwdir)
			system(sprintf("ln -s %s/../etc/init/lin32/13.3/messages/ja_JP.eucJP/FJSVstem.msg /usr/share/locale/ja_JP.eucJP/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
			system(sprintf("ln -s %s/../etc/init/lin32/13.3/messages/ja_JP.UTF-8/FJSVstem.msg /usr/share/locale/ja_JP.UTF-8/LC_MESSAGES/FJSVstem.cat >/dev/null 2>&1", pwdir))
		} else {
			cmd_stemSchDelete = "/opt/FJSVstem/bin/stemSchDelete"
		}
	}

	# stemSchDeleteޥɤ¹
	rc_jobstem = stemSchDelete_proc(subsystem, prj_lst, cmd_stemSchDelete)
	if (rc_jobstem != 0) {
		return (2)
	}

	return (0)
}



#*****************************************************************************
# jobschprint -o ޥɤ¹Ԥץ̾
#       subsystem :֥ƥֹ
#           all_flag  :"-all"ե饰
#           prj_lst   :ץ̾Ǽꥹ
#   ֤  0  :ｪλ
#           1  :۾ｪλ
#*****************************************************************************
function jobschprint_o_proc(subsystem, all_flag, prj_lst) {
	# jobschprint-o ޥɤ¹
	if (edition ~ /Standard Edition/) {
		if (version ~ /13.3/) {
			rc_printo = system(sprintf("/usr/bin/jobschprint -o -long >%s 2>&1", TMPFILE))
		} else {
			rc_printo = system(sprintf("/usr/bin/jobschprint -o >%s 2>&1", TMPFILE))
		}
	} else {
		if (version ~ /13.3/) {
			rc_printo = system(sprintf("/usr/bin/jobschprint -o -long -sys %s >%s 2>&1", subsystem, TMPFILE))
		} else {
			rc_printo = system(sprintf("/usr/bin/jobschprint -o -sys %s >%s 2>&1", subsystem, TMPFILE))
		}
	}
	# ޥɤ˼Ԥ硢顼å 
	print_flag = 0
	if ((all_flag == 0) || ((subsystem == 9) && (allerr_flag == 1) && (stemerr_flag == 0))) {
		print_flag = 1
	}
	if (rc_printo != 0) {
		# եɤ߹
		cmd = sprintf("cat '%s'", TMPFILE)
		if (print_flag == 1) {
			while (cmd | getline > 0) {
				rl = $0
				printf("%s\n", rl)
			}
			printf("%s\n", errmsg[ERRMSG_GETFAILED])
		}
		close(cmd)
		# ե
		system(sprintf("rm -f '%s'", TMPFILE))
		return (1)
	}
	# ޥɤνϤץ̾
	j=1
	prj_flag = 0
	cmd = sprintf("cat '%s'", TMPFILE)
	while (cmd | getline > 0) {
		rl =$0
		# ץ̾ꥹȤɲ
		if ((prj_flag == 1) && (rl != "")) {
			split(rl, p)
			prj_lst[j] = p[1]
			j = j + 1
		}
		# "Project Name","Access","Owner Name"ޤ༡ιԤץ̾
		if ((rl ~ /Project Name/) && (rl ~ /Access/) && (rl ~ /Owner Name/)) {
			prj_flag = 1
		}
	}
	close(cmd)
	# եκ
	system(sprintf("rm -f '%s'", TMPFILE))
	return (0)
}



#*****************************************************************************
# stemSchDeleteޥɤ¹ԤץȤ
#       subsystem         :֥ƥֹ
#           prj_list          :ץ̾Ǽꥹ
#           cmd_stemSchDelete :stemSchDeleteޥɤΥѥ
#*****************************************************************************
function stemSchDelete_proc(subsystem, prj_lst, cmd_stemSchDelete) {
	err_flag = 0
	# ꥹΥץȤФơstemSchDeleteޥɤ¹
	for (j=1; prj_lst[j] != ""; j++) {
		x = prj_lst[j]
		x = sprintf("\"%s\"", x)
		# SEξ
		if (edition ~ /Standard Edition/) {
			rc_del = system(sprintf("env NLSPATH=/usr/share/locale/%L/%N %s %s >/dev/null 2>&1", 
					 cmd_stemSchDelete, x))
		# EEξ
		} else {
			rc_del = system(sprintf("%s %s -sys %s >/dev/null 2>&1",
                               	         cmd_stemSchDelete, x, subsystem))

		}
		# ޥɤ˼Ԥ硢顼å
		if (rc_del != 0) {
			printf("%s%s\n", prj_lst[j], errmsg[ERRMSG_DELFAILED])
			err_flag = 1
		}
	}

	#
	if (err_flag == 1) {
		return (1)
	}
	return (0)
}



function get_release(rel_array) {
	#
	RELFILE = "/etc/redhat-release"
	cmd = sprintf("cat '%s'", RELFILE)
	#
	rc_getrel = system(sprintf("ls %s >/dev/null 2>&1", RELFILE))
	if (rc_getrel != 0) {
		printf("%s\n", errmsg[ERRMSG_DELFAILED])
		return (1)
	}
	
	rel_array[1] = ""
	while (cmd | getline > 0) {
		rl = $0
		#
		if (rl ~ /release 4/) {
			rel_array[1] = "RedHat4"
		}
	}
	if (rel_array[1] == "") {
		rel_array[1] = "RedHat5"
	}
	close(cmd)

	return (0)
}
